import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetLatestConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetLatestConfigurationCommand, se_GetLatestConfigurationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetLatestConfigurationCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AppConfigData", "GetLatestConfiguration", {})
    .n("AppConfigDataClient", "GetLatestConfigurationCommand")
    .f(void 0, GetLatestConfigurationResponseFilterSensitiveLog)
    .ser(se_GetLatestConfigurationCommand)
    .de(de_GetLatestConfigurationCommand)
    .build() {
}
