import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { AppConfigDataClientResolvedConfig } from "../AppConfigDataClient";
export interface AppConfigDataHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface AppConfigDataHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    AppConfigDataClientResolvedConfig,
    HandlerExecutionContext,
    AppConfigDataHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultAppConfigDataHttpAuthSchemeParametersProvider: (
  config: AppConfigDataClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<AppConfigDataHttpAuthSchemeParameters>;
export interface AppConfigDataHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<AppConfigDataHttpAuthSchemeParameters> {}
export declare const defaultAppConfigDataHttpAuthSchemeProvider: AppConfigDataHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: AppConfigDataHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: AppConfigDataHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
