import { Command as $Command } from "@smithy/smithy-client";
import { MetadataBearer as __MetadataBearer } from "@smithy/types";
import { Uint8ArrayBlobAdapter } from "@smithy/util-stream";
import {
  AppConfigDataClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../AppConfigDataClient";
import {
  GetLatestConfigurationRequest,
  GetLatestConfigurationResponse,
} from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export interface GetLatestConfigurationCommandInput
  extends GetLatestConfigurationRequest {}
export type GetLatestConfigurationCommandOutputType = Pick<
  GetLatestConfigurationResponse,
  Exclude<keyof GetLatestConfigurationResponse, "Configuration">
> & {
  Configuration?: Uint8ArrayBlobAdapter;
};
export interface GetLatestConfigurationCommandOutput
  extends GetLatestConfigurationCommandOutputType,
    __MetadataBearer {}
declare const GetLatestConfigurationCommand_base: {
  new (
    input: GetLatestConfigurationCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    GetLatestConfigurationCommandInput,
    GetLatestConfigurationCommandOutput,
    AppConfigDataClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (
    input: GetLatestConfigurationCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    GetLatestConfigurationCommandInput,
    GetLatestConfigurationCommandOutput,
    AppConfigDataClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class GetLatestConfigurationCommand extends GetLatestConfigurationCommand_base {
  protected static __types: {
    api: {
      input: GetLatestConfigurationRequest;
      output: GetLatestConfigurationResponse;
    };
    sdk: {
      input: GetLatestConfigurationCommandInput;
      output: GetLatestConfigurationCommandOutput;
    };
  };
}
